<?php

$tidy = new tidy();

$db = new SQLite3('aol.db');
$db->exec("CREATE TABLE IF NOT EXISTS news(id INTEGER PRIMARY KEY ASC, author TEXT, category INTEGER, title TEXT, content TEXT)");
$stm = $db->prepare("INSERT or REPLACE INTO news(id, author, category, title, content) VALUES (?, ?, ?, ?, ?)");
$stm->bindParam(1, $id);
$stm->bindParam(2, $author);
$stm->bindParam(3, $category);
$stm->bindParam(4, $title);
$stm->bindParam(5, $content);

////////////////////////////////////////////////////////
// Function:         replace_news
// Description: Replaces news charactars
function replace_news($sourse){

    $find= array(

/* 1 */                              "'\[upimage=([^\]]*?) ([^\]]*?)\]'i",
/* 2 */                                        "'\[upimage=(.*?)\]'i",
/* 3 */                                        "'\[b\](.*?)\[/b\]'i",
/* 4 */                                        "'\[i\](.*?)\[/i\]'i",
/* 5 */                                        "'\[u\](.*?)\[/u\]'i",
/* 6 */                                        "'\[link\](.*?)\[/link\]'i",
/* 7 */                                        "'\[color=(.*?)\](.*?)\[/color\]'i",
/* 8 */                                        "'\[size=(.*?)\](.*?)\[/size\]'i",
/* 9 */                                        "'\[font=(.*?)\](.*?)\[/font\]'i",
/* 10 */                                 "'\[align=(.*?)\](.*?)\[/align\]'i",
/* 12 */                                 "'\[image=(.*?)\]'i",
/* 13 */                                 "'\[link=(.*?)\](.*?)\[/link\]'i",

/* 14 */                "'\[quote=(.*?)\](.*?)\[/quote\]'i",
/* 15 */                "'\[quote\](.*?)\[/quote\]'i",

/* 16 */                "'\[list\]'i",
/* 17 */                "'\[/list\]'i",
/* 18 */                "'\[\*\]'i",

                            "'{nl}'",
    );

    $replace=array(

/* 1 */                                        "<img \\2 src=\"/cn/skins/images/upskins/images/\\1\" style=\"border: none;\" alt=\"\" />",
/* 2 */                                        "<img src=\"/cn/skins/images/upskins/images/\\1\" style=\"border: none;\" alt=\"\" />",
/* 3 */                                        "<strong>\\1</strong>",
/* 4 */                                        "<em>\\1</em>",
/* 5 */                                        "<span style=\"text-decoration: underline;\">\\1</span>",
/* 6 */                                        "<a href=\"\\1\">\\1</a>",
/* 7 */                                        "<span style=\"color: \\1;\">\\2</span>",
/* 8 */                                        "<span style=\"font-size: \\1pt;\">\\2</span>",
/* 9 */                                        "<span style=\"font-family: \\1;\">\\2</span>",
/* 10 */                                "<div style=\"text-align: \\1;\">\\2</div>",
/* 12 */                                "<img src=\"\\1\" style=\"border: none;\" alt=\"\" />",
/* 13 */                                "<a href=\"\\1\">\\2</a>",

/* 14 */                                "<blockquote><div style=\"font-size: 13px;\">quote (\\1):</div><hr style=\"border: 1px solid #ACA899;\" /><div>\\2</div><hr style=\"border: 1px solid #ACA899;\" /></blockquote>",
/* 15 */                                "<blockquote><div style=\"font-size: 13px;\">quote:</div><hr style=\"border: 1px solid #ACA899;\" /><div>\\1</div><hr style=\"border: 1px solid #ACA899;\" /></blockquote>",

/* 16 */                                "<ul>",
/* 17 */                                "</ul>",
/* 18 */                                "<li>",

                                            "\n",
    );

    return preg_replace($find,$replace,$sourse);
}

$ISO_CHARS_1 = array (
    '&#261;' => 'ą',
    '&#260;' => 'Ą',
    '&#263;' => 'ć',
    '&#262;' => 'Ć',
    '&#281;' => 'ę',
    '&#280;' => 'Ę',
    '&#322;' => 'ł',
    '&#321;' => 'Ł',
    '&#324;' => 'ń',
    '&#323;' => 'Ń',
    '&#243;' => 'ó',
    '&#211;' => 'Ó',
    '&#347;' => 'ś',
    '&#346;' => 'Ś',
    '&#378;' => 'ź',
    '&#377;' => 'Ź',
    '&#380;' => 'ż',
    '&#379;' => 'Ż',
);

$ISO_CHARS_2 = array (
    '&#261' => 'ą',
    '&#260' => 'Ą',
    '&#263' => 'ć',
    '&#262' => 'Ć',
    '&#281' => 'ę',
    '&#280' => 'Ę',
    '&#322' => 'ł',
    '&#321' => 'Ł',
    '&#324' => 'ń',
    '&#323' => 'Ń',
    '&#243' => 'ó',
    '&#211' => 'Ó',
    '&#347' => 'ś',
    '&#346' => 'Ś',
    '&#378' => 'ź',
    '&#377' => 'Ź',
    '&#380' => 'ż',
    '&#379' => 'Ż',
);

//-------------------------------------------------------------------

// tac news.txt > invert-news.txt
$fn = fopen('invert-news.txt', 'r') or die('I can not open the file.');

while(!feof($fn))  {
    $rLine = fgets($fn);
    if ($rLine) {
        $rLine = mb_convert_encoding($rLine, 'UTF-8', 'ISO-8859-2');
        $rLine = strtr($rLine, $ISO_CHARS_1);
        $rLine = strtr($rLine, $ISO_CHARS_2);          
        $arrNews = explode('|', $rLine);       
        if ($arrNews[6] != '3'){
            $arrCategory = explode(',', $arrNews[6]);
            $category = $arrCategory[0];
            if (sizeof($arrCategory) == 2) {
                $category = $arrCategory[1];
            }

            $content = $arrNews[3];
            $content = replace_news($content);
            $tidy->parseString($content, array(), 'utf8');
            $tidy->cleanRepair();
            $content = $tidy->Body()->value;
            $content = str_replace(array("<body>\n", "</body>\n"), '', $content);

            $id         = intval($arrNews[0]);
            $author     = $arrNews[1];
            $category   = intval($category);
            $title      = $arrNews[2];
            $content    = $content;
            
            $stm->execute();
            
        }  else {                
            echo $arrNews[0]      // id
            . '|' . $arrNews[1]   // author
            . '|' . $arrNews[2]   // title      
            . '|' . $arrNews[6]   // status
            . PHP_EOL;
        }
    }
}

fclose($fn);
